//
//  AppDelegate.m
//  IntregratingRTMTutorial
//
//  Created by Michael Keith on 30/12/11.
//  Copyright (c) 2011 Ziggurat. All rights reserved.
//

#import "AppDelegate.h"
#import "RTMManager.h"

@implementation AppDelegate

@synthesize window = _window;
@synthesize authenticateWindow = _authenticateWindow;
@synthesize webView = _webView;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(showAuthenticateWindow:) name:@"showauthenticatewindow" object:nil]; // 1
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(windowDidClose:) name: NSWindowWillCloseNotification object:nil]; // 2

    // Insert code here to initialize your application
    [[RTMManager sharedRTMManager] authenticate]; // 3
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:nil];
}

- (void)showAuthenticateWindow:(NSNotification *)notification {
    // 4
    NSString *urlString = notification.object;
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *urlRequest = [NSURLRequest requestWithURL:url];
    [self.webView.mainFrame loadRequest:urlRequest];
    [self.authenticateWindow setIsVisible:YES];
}

- (void)windowDidClose:(NSNotification *)notification {
    // 5
    if (notification.object == self.authenticateWindow) {
        [[NSNotificationCenter defaultCenter] postNotificationName:@"authenticatecomplete" object:nil];
    }
}
@end
