//
//  TableController.m
//  IntegratingRTMTutorial3
//
//  Created by Michael Keith on 2/01/12.
//  Copyright (c) 2012 Ziggurat. All rights reserved.
//

#import "TableController.h"
#import "Task.h"
#import "TaskSeries.h"
#import "TaskManager.h"

@implementation TableController {
    NSArray *tasks;
}

@synthesize tableView;

- (id)init {
    self = [super init];
    if (self) {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(taskListUpdated:) name:@"tasklistupdatednotification" object:nil];
    }
    return self;
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)taskListUpdated:(NSNotification *)notification {
    tasks = [[TaskManager sharedTaskManager] tasks];
    [self.tableView reloadData];
}

#pragma mark - NSTableViewDataSource

- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView {
    return tasks.count;    
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row {
    Task *task = [tasks objectAtIndex:row];
    if ([tableColumn.identifier isEqualToString:@"name"]) {
        return task.ownerTaskSeries.name;
    }

    return task.dateDue;
}

@end
